package xyz.twovb.sgm.commands.handlers;

import dev.rollczi.litecommands.handler.result.ResultHandlerChain;
import dev.rollczi.litecommands.invalidusage.InvalidUsage;
import dev.rollczi.litecommands.invalidusage.InvalidUsageHandler;
import dev.rollczi.litecommands.invocation.Invocation;
import dev.rollczi.litecommands.schematic.Schematic;
import org.bukkit.command.CommandSender;

import xyz.twovb.sgm.SGM;
import xyz.twovb.toolbox.managers.PlaceholderManager;
import xyz.twovb.toolbox.utils.ChatUtils;


import java.util.List;

public class InvalidArgsHandler implements InvalidUsageHandler<CommandSender> {
    @Override
    public void handle(Invocation<CommandSender> invocation, InvalidUsage<CommandSender> result, ResultHandlerChain<CommandSender> chain) {
        CommandSender sender = invocation.sender();
        Schematic schematic = result.getSchematic();
        String message = SGM.getInstance().getMessages().getString("commands.wrong-args");
        StringBuilder builder = new StringBuilder();
        builder.insert(0, "\n");
        if (schematic.isOnlyFirst()) {
            // borken idk why ill fix later
            message = message.replace("%usage%", "\n&8 - &7" + schematic.first());
        } else {
            List<String> schemes = schematic.all();
            for (int i = 0; i < schemes.size(); i++) {
                String scheme = schemes.get(i);

                // Append the formatted scheme entry
                builder.append("&8 - &7").append(scheme);

                // Check if the current element is not the last one
                if (i < schemes.size() - 1) {
                    builder.append("\n");  // Append newline if not the last element
                }
            }
            message = message.replace("%usage%", builder.toString());
        }
        sender.sendMessage(ChatUtils.translate(PlaceholderManager.setPlaceholders(message, sender)));
    }
}