package xyz.twovb.sgm.commands.impl;
/*
 * Created by 2vb - 4/6/2024
 */

import dev.rollczi.litecommands.annotations.argument.Arg;
import dev.rollczi.litecommands.annotations.command.Command;
import dev.rollczi.litecommands.annotations.context.Context;
import dev.rollczi.litecommands.annotations.execute.Execute;
import dev.rollczi.litecommands.annotations.permission.Permission;
import org.bukkit.command.CommandSender;
import xyz.twovb.sgm.SGM;
import xyz.twovb.sgm.levels.LevelManager;
import xyz.twovb.toolbox.managers.PlaceholderManager;
import xyz.twovb.toolbox.utils.ChatUtils;

import java.util.Optional;
import java.util.UUID;

@Command(name = "level")
public class LevelCommand {

    @Execute(name = "create")
    @Permission("sgm.levels.create")
    void create(@Context CommandSender sender, @Arg("name") Optional<String> LevelName) {
        LevelManager mm = new LevelManager();
        String name = LevelName.orElse(UUID.randomUUID().toString());
        if (mm.createLevel(name)) {
            sender.sendMessage(ChatUtils.translate(PlaceholderManager.setPlaceholders(SGM.getInstance().getMessages().getString("sgm.level.new"), sender).replace("%level%", name)));
        } else {
            sender.sendMessage(ChatUtils.translate(PlaceholderManager.setPlaceholders(SGM.getInstance().getMessages().getString("sgm.level.exists"), sender).replace("%level%", name)));
        }
    }

}
