package xyz.twovb.sgm.games;

/*
 * Created by 2vb - 4/6/2024
 */

import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import xyz.twovb.toolbox.api.ToolPlayer;

import java.util.List;
import java.util.UUID;

public interface Minigame extends Listener {

    enum GameState {
        PRESTART,
        READY,
        STARTED,
        ENDING
    }

    void init(CommandSender owner);
    void start();
    void stop();
    void addPlayer(Player player);
    void removePlayer(Player player);
    List<Player> getPlayers();
    void onTick();
    String getName();
    UUID getGameId();
    GameState getState();
    CommandSender getOwner();
    default void sendMessageToAllPlayers(String message) {
        for (Player player : getPlayers()) {
            ToolPlayer toolPlayer = new ToolPlayer(player);
            toolPlayer.sendMessage(message);
        }
    }

}
